=== debian/changelog ===
yubihsm-shell (2.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Mark libyubihsm-dev, libykhsmauth-dev, and yubihsm-pkcs11 as Multi-Arch:
    same.

 -- Colin Watson <cjwatson@debian.org>  Fri, 23 Jan 2026 11:16:58 +0000

yubihsm-shell (2.7.0-4) unstable; urgency=medium

  * Drop "Rules-Requires-Root: no", default as of dpkg-dev 1.22.13.
  * Standards-Version: 4.7.2.

 -- Colin Watson <cjwatson@debian.org>  Sun, 23 Nov 2025 12:01:32 +0000
